/************************************************************************************
*                                 JavaScript project:                               *
*                                      Systometer                                   *
*                                    Monitor Object                                 *
*                                                                                   *
*                                 20©08 f.e.d studios                               *
*                             http://www.fed-studios.com                            *
************************************************************************************/

function monitorObject(){
	var mObj = {
		service : null,
		refresher : null,
		netMonitor : null,
		ramMonitor : null,
		cpuMonitor : null,
		net : null,
		ram : null,
		cpu : null,
		networkCardNames : null,
		netDown : null,
		netUp : null,
		netBandwidth : null,
		ramUsed : null,
		cpuUsed : null,
		init : function(){
			mObj.service = GetObject('winmgmts:');
			mObj.refresher = new ActiveXObject("WbemScripting.SWbemRefresher");
			mObj.netMonitor = mObj.refresher.AddEnum(mObj.service, "Win32_PerfFormattedData_Tcpip_NetworkInterface").ObjectSet;
			mObj.ramMonitor = mObj.refresher.AddEnum(mObj.service, "Win32_PerfFormattedData_PerfOS_Memory").ObjectSet;
			mObj.cpuMonitor = mObj.refresher.AddEnum(mObj.service, "Win32_PerfFormattedData_PerfOS_Processor").ObjectSet;
		},
		update : function(networkCardIndex){			
			mObj.refresher.Refresh();
			mObj.net = new Enumerator(mObj.netMonitor);
			mObj.ram = new Enumerator(mObj.ramMonitor);
			mObj.cpu = new Enumerator(mObj.cpuMonitor);
			for(var i=0; !mObj.net.atEnd(); mObj.net.moveNext() & i++ ){
				if(i == networkCardIndex){
					mObj.netDown = Math.round(mObj.net.item().BytesReceivedPersec / 1024);
					mObj.netUp = Math.round(mObj.net.item().BytesSentPersec / 1024);
					mObj.netBandwidth = mObj.net.item().CurrentBandwidth;
				}
			}
			
			var ramTotal = System.Machine.totalMemory;
			var ramUsed = (System.Machine.totalMemory - System.Machine.availableMemory);
			/*var ramItems = 0;
			for(var r=0; !mObj.ram.atEnd(); mObj.ram.moveNext() & r++ ){
				ramTotal = ramTotal + mObj.ram.item().PercentCommittedBytesInUse;
				ramItems = r + 1;
			}*/
			mObj.ramUsed = Math.round((ramUsed * 100) / ramTotal);
			
			mObj.cpuUsed = mObj.cpu.item().PercentProcessorTime;
		},
		getNames : function(){
			mObj.networkCardNames = new Array;
			mObj.refresher.Refresh();
			mObj.net = new Enumerator(mObj.netMonitor);
			for(var i=0; !mObj.net.atEnd(); mObj.net.moveNext() & i++ ){
				mObj.networkCardNames.push(mObj.net.item().Name);
			}
		}
	};
	return mObj;
}