/************************************************************************************
*                                 JavaScript project:                               *
*                                      Systometer                                   *
*                                       Settings                                    *
*                                                                                   *
*                                 20©08 f.e.d studios                               *
*                             http://www.fed-studios.com                            *
************************************************************************************/

var gsObj, themeObj, monitorObj;
var selectedTheme, maxUpBandwidth, maxDownBandwidth;

function initSettings(){
	System.Gadget.onSettingsClosing = settingsClosing;
	gso = new gadgetSettingsObject();
	
	monitorObj = new monitorObject();
	monitorObj.init();
	monitorObj.getNames();
	
	for(var i=0; i < monitorObj.networkCardNames.length; i++){
         document.getElementById('networkCard').options[i] = new Option(monitorObj.networkCardNames[i], monitorObj.networkCardNames[i]);
    }
	
	updateGSO();
	
	bgThemes = new themes();
	bgThemes.update();
	document.getElementById('themePreview').style.backgroundImage = bgThemes.list[selectedTheme].image;
	document.getElementById('themePreview').style.backgroundRepeat = 'no-repeat';
	document.getElementById('themePreview').style.backgroundPosition = 'center center';
	document.getElementById('themeName').innerHTML = bgThemes.list[selectedTheme].name;
		
}

function stepBack(){
	if(selectedTheme > 0){
		selectedTheme = selectedTheme - 1;
	}else{
		selectedTheme = bgThemes.list.length - 1;
	}
	document.getElementById('themePreview').style.backgroundImage = bgThemes.list[selectedTheme].image;
	document.getElementById('themeName').innerHTML = bgThemes.list[selectedTheme].name;
}

function stepForward(){
	if(selectedTheme < bgThemes.list.length - 1){
		selectedTheme = selectedTheme + 1;
	}else{
		selectedTheme = 0;
	}
	document.getElementById('themePreview').style.backgroundImage = bgThemes.list[selectedTheme].image;
	document.getElementById('themeName').innerHTML = bgThemes.list[selectedTheme].name;
}

function settingsClosing(event){
	if (event.closeAction == event.Action.commit){
    	writeGSO();
    }
}

function writeGSO(){
	gso.selectedNetworkCardIndex = document.getElementById('networkCard').selectedIndex;
	gso.theme = selectedTheme;
	gso.maxUpBandwidth = parseInt(document.getElementById('upSpeed').value);
	gso.maxDownBandwidth = parseInt(document.getElementById('downSpeed').value);
	gso.saveSettings();
}

function updateGSO(){	
	gso.loadSettings();
	document.getElementById('networkCard').selectedIndex = gso.selectedNetworkCardIndex;
	selectedTheme = gso.theme;
	maxUpBandwidth = gso.maxUpBandwidth;
	maxDownBandwidth = gso.maxDownBandwidth;
	switch(maxUpBandwidth){
		case 10000000:
			document.getElementById('upSpeed').selectedIndex = 0;
			break;
		case 100000000:
			document.getElementById('upSpeed').selectedIndex = 1;
			break;
		case 1000000000:
			document.getElementById('upSpeed').selectedIndex = 2;
			break;
	}
	switch(maxDownBandwidth){
		case 10000000:
			document.getElementById('downSpeed').selectedIndex = 0;
			break;
		case 100000000:
			document.getElementById('downSpeed').selectedIndex = 1;
			break;
		case 1000000000:
			document.getElementById('downSpeed').selectedIndex = 2;
			break;
	}
}