/************************************************************************************
*                                 JavaScript project:                               *
*                                      Systometer                                   *
*                                                                                   *
*                                                                                   *
*                                 20©08 f.e.d studios                               *
*                             http://www.fed-studios.com                            *
************************************************************************************/

function init(){
	System.Gadget.settingsUI = '../html/settings.html';
	System.Gadget.onSettingsClosed = settingsClosed;
	gSettingsObj = new gadgetSettingsObject();
	updateSettings();
	gThemesObj = new themes();
	gThemesObj.update();
	setTheme();
	
	setHands(-60, -60, -60, -60);
	
	gMonitorObj = new monitorObject();
	gMonitorObj.init();
	updateInfo();
	updateTimer = setInterval(updateInfo, 1000);
}

function settingsClosed(event){
	if (event.closeAction == event.Action.commit){
		updateSettings();
		setTheme();
    }	
	self.focus();
}

function writeSettings(){
	gSettingsObj.selectedNetworkCardIndex = selectedNetworkCardIndex;
	gSettingsObj.theme = selectedTheme;
	gSettingsObj.maxUpBandwidth = maxUpBandwidth;
	gSettingsObj.maxDownBandwidth = maxDownBandwidth;
	gSettingsObj.saveSettings();
}

function updateSettings(){	
	gSettingsObj.loadSettings();
	selectedNetworkCardIndex = gSettingsObj.selectedNetworkCardIndex;
	selectedTheme = gSettingsObj.theme;
	maxUpBandwidth = gSettingsObj.maxUpBandwidth;
	maxDownBandwidth = gSettingsObj.maxDownBandwidth;
}

function setTheme(){
	document.body.style.backgroundImage = gThemesObj.list[selectedTheme].image;
	document.body.style.color = gThemesObj.list[selectedTheme].color;
}

function updateInfo(){
	gMonitorObj.update(selectedNetworkCardIndex);
	document.getElementById('cpuInfo').innerHTML = gMonitorObj.cpuUsed + '%';
	document.getElementById('ramInfo').innerHTML = gMonitorObj.ramUsed + '%';
	if(gMonitorObj.netUp < 1000){
		document.getElementById('netInfoUp').innerHTML = gMonitorObj.netUp + ' kbs';
	}else if((gMonitorObj.netUp >= 1000) && (gMonitorObj.netUp < 1000000)){
		document.getElementById('netInfoUp').innerHTML = Math.round(gMonitorObj.netUp / 1000) + ' Mbs';
	}else if(gMonitorObj.netUp >= 1000000){
		document.getElementById('netInfoUp').innerHTML = Math.round(gMonitorObj.netUp / 1000000) + ' Gbs';
	}
	if(gMonitorObj.netDown < 1000){
		document.getElementById('netInfoDown').innerHTML = gMonitorObj.netDown + ' kbs';
	}else if((gMonitorObj.netDown >= 1000) && (gMonitorObj.netDown < 1000000)){
		document.getElementById('netInfoDown').innerHTML = Math.round(gMonitorObj.netDown / 1000) + ' Mbs';
	}else if(gMonitorObj.netDown >= 1000000){
		document.getElementById('netInfoDown').innerHTML = Math.round(gMonitorObj.netDown / 1000000) + ' Gbs';
	}
	var cpuRotation = -60 + ((300 * gMonitorObj.cpuUsed) / 100);
	var ramRotation = -60 + ((300 * gMonitorObj.ramUsed) / 100);
	var upRotation = -60 + Math.round((300 * (((gMonitorObj.netUp * 100000) * 1.024) / maxUpBandwidth)) / 100);
	var downRotation = -60 + Math.round((300 * (((gMonitorObj.netDown * 100000) * 1.024) / maxDownBandwidth)) / 100);
	setHands(cpuRotation, ramRotation, upRotation, downRotation);
}

function setHands(r0, r1, r2, r3){
	cpu.rotation = r0;
	ram.rotation = r1;
	up.rotation = r2;
	down.rotation = r3;
}